'use strict';

exports.__esModule = true;
exports.hasClass = hasClass;
exports.addClass = addClass;
exports.removeClass = removeClass;

function hasClass(el, className) {
    if (!el) {
        return;
    }
    if (el.classList) return el.classList.contains(className);else return !!el.className.match(new RegExp('(\\s|^)' + className + '(\\s|$)'));
}

function addClass(el, className) {
    if (!el) {
        return;
    }
    if (el.classList) {
        el.classList.add(className);
    } else if (!hasClass(el, className)) el.className += " " + className;
}

function removeClass(el, className) {
    if (!el) {
        return;
    }
    if (el.classList) {
        el.classList.remove(className);
    } else if (hasClass(el, className)) {
        var reg = new RegExp('(\\s|^)' + className + '(\\s|$)');
        el.className = el.className.replace(reg, ' ');
    }
}